﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class EnemyManager : MonoBehaviour 
{
    public List<EnemyBase> allEnemies;

	// Use this for initialization
	void Start ()
    {
	
	}
	
    void UpdateEnemyList()
    {
        allEnemies = new List<EnemyBase>(GetComponentsInChildren<EnemyBase>());
    }

	// Update is called once per frame
	void Update () 
    {
        UpdateEnemyList();
	}

    public EnemyBase GimmeSomethingToKill(Vector3 vMyLocation, Vector3 vMyFacing, bool bPleaseTargetInFiringCone)
    {
        float fBestDist = float.MaxValue;
        EnemyBase bestFoe = null;
        int iBestLockCount = 999;
        foreach (EnemyBase maybeEnemy in allEnemies)
        {
            if (maybeEnemy == null)
                continue;

            if (iBestLockCount < maybeEnemy.iNumWeaponLocksOnMe)
                continue;

            Vector3 vToTarget = maybeEnemy.transform.position - vMyLocation;

            if (bPleaseTargetInFiringCone && Vector3.Dot(vToTarget, vMyFacing) < 0.0f )
                continue;

            float dist = (maybeEnemy.transform.position - transform.position).sqrMagnitude;
            if (dist < fBestDist)
            {
                fBestDist = dist;
                bestFoe = maybeEnemy;
                iBestLockCount = maybeEnemy.iNumWeaponLocksOnMe;
            }

        }

        if (bestFoe != null)
            bestFoe.iNumWeaponLocksOnMe++;

        return bestFoe;
    }

    public void KillAll()
    {
        foreach (EnemyBase maybeEnemy in allEnemies)
        {
            if (maybeEnemy == null)
                continue;

            maybeEnemy.TakeDamage(1000);
        }
    }
}
