﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using Random = UnityEngine.Random;

public class GameManager : MonoBehaviour 
{

    [HideInInspector]
    public float fTruckSpeed;

    public float BaselineTruckSpeed = 10.0f;

    public bool bBoostEngaged;
    public bool bShotEngaged;

    private PlayerTruck theTruck;

    public Texture tex_BoostGaugeEmpty;
    public Texture tex_BoostGaugeFilled;
    public Texture tex_ShotGaugeOneBullet;
    public Texture tex_ShotGaugeGlow;

    public Camera mainCamera;

    public GUIStyle fontStyle;

    public int iScore;

    public float fShowMessageTextureTimer;
    public Texture texMessage;

    public Texture wave1Intro;
    public Texture wave2Intro;
    public Texture wave3Intro;
    public Texture wave4Intro;

    public Texture tex_ExplainRamming;
    public Texture tex_ExplainRamming_02;

    public List<Texture> staticTextures;
    public int iStaticIdx;
    public bool bStaticMode;

    public AudioClip clip_shortStatic;
    public AudioClip clip_longStatic;

    public int iStaticBurstCounts;
    public int iFramesToDoStatic;

    public WaveManager theWaveManager;

    public bool bGameOver;
    public float fGameIsOverTimer;

    public AudioClip clip_gameOverYeah;
    public Texture tex_gameOverYeah;

    private bool bPlayedGameOverYeah;

	// Use this for initialization
	void Start ()
	{
	    theTruck = GameObject.Find("PlayerTruck").GetComponent<PlayerTruck>();
	    theWaveManager = GameObject.Find("WaveManager").GetComponent<WaveManager>();


        mainCamera = Camera.main;

        PrepareToShowMessage(wave1Intro);
	}

    public void PrepareToShowMessage(Texture tex)
    {
        fShowMessageTextureTimer = 10.0f;
        texMessage = tex;
    }

    public bool IsGameOver()
    {
        return fGameIsOverTimer > 0.0f;
    }

    public void DoQuickStatic()
    {
        bStaticMode = true;
        iFramesToDoStatic = Random.Range(1, 5);
        PlayClip(clip_shortStatic);
    }

    public void GameOverStatic()
    {
        bStaticMode = true;
        iFramesToDoStatic = -999;
        PlayClip(clip_longStatic);
        bGameOver = true;
    }

	// Update is called once per frame
	void Update () 
    {
	    if (iFramesToDoStatic == -999 || iFramesToDoStatic > 0)
	    {
	        bStaticMode = true;
	    }

        //game over static
	    if (theWaveManager.IsStaticReady() && Random.value <= 0.005f && fGameIsOverTimer <= 0.0f)
	    {
	        iStaticBurstCounts++;
            if( iStaticBurstCounts < 6)
    	        DoQuickStatic();
            else
                GameOverStatic();
	    }

	    if (bGameOver)
	        fGameIsOverTimer += Time.deltaTime;

	    UpdateInput();
	    UpdateDebugGunCrap();

	    float xDelta = theTruck.transform.position.x;
	    xDelta *= -1.25f;

	    if (xDelta > 0)
	    {

	    }
	    else
	    {
	        xDelta = 360.0f + xDelta;
	    }

	    mainCamera.transform.rotation = Quaternion.AngleAxis(xDelta, new Vector3(0f, 0f, 1f));


	    
        iScore += (int)Math.Max(100.0f *Time.deltaTime, 1.0f);
	    if (bBoostEngaged)
	        iScore += 5;


    }

    public void AddScore(int i)
    {
        iScore += i;
    }

    void UpdateDebugGunCrap()
    {
       
    }

    public bool IsBoostBeingMashed()
    {
        if (IsGameOver())
            return false;

        return

            Input.GetKey(KeyCode.Q) ||
            Input.GetKey(KeyCode.W) ||
            Input.GetKey(KeyCode.E) ||
            Input.GetKey(KeyCode.R) ||
            Input.GetKey(KeyCode.T) ||
            Input.GetKey(KeyCode.A) ||
            Input.GetKey(KeyCode.S) ||
            Input.GetKey(KeyCode.D) ||
            Input.GetKey(KeyCode.F) ||
            Input.GetKey(KeyCode.G) ||
            Input.GetKey(KeyCode.Z) ||
            Input.GetKey(KeyCode.X) ||
            Input.GetKey(KeyCode.V) ||
            Input.GetKey(KeyCode.C) ||
            Input.GetKey(KeyCode.B) ||
            Input.GetKey(KeyCode.Alpha1) ||
            Input.GetKey(KeyCode.Alpha2) ||
            Input.GetKey(KeyCode.Alpha3) ||
            Input.GetKey(KeyCode.Alpha4) ||
            Input.GetKey(KeyCode.Alpha5) ||
            Input.GetKey(KeyCode.Tab) ||
            Input.GetKey(KeyCode.CapsLock) ||
            Input.GetKey(KeyCode.LeftShift) ||
            Input.GetKey(KeyCode.LeftControl) ||
            Input.GetKey(KeyCode.LeftCommand) ||
            Input.GetKey(KeyCode.LeftAlt) ||
            Input.GetKey(KeyCode.BackQuote);
    }


    public bool IsShootBeingMashed()
    {
        if (IsGameOver())
            return false;

        return

            Input.GetKey(KeyCode.Y) ||
            Input.GetKey(KeyCode.U) ||
            Input.GetKey(KeyCode.I) ||
            Input.GetKey(KeyCode.O) ||
            Input.GetKey(KeyCode.P) ||
            Input.GetKey(KeyCode.H) ||
            Input.GetKey(KeyCode.J) ||
            Input.GetKey(KeyCode.K) ||
            Input.GetKey(KeyCode.L) ||
            Input.GetKey(KeyCode.N) ||
            Input.GetKey(KeyCode.Alpha6) ||
            Input.GetKey(KeyCode.Alpha7) ||
            Input.GetKey(KeyCode.Alpha8) ||
            Input.GetKey(KeyCode.Alpha9) ||
            Input.GetKey(KeyCode.Alpha0) ||
            Input.GetKey(KeyCode.LeftBracket) ||
            Input.GetKey(KeyCode.RightBracket) ||
            Input.GetKey(KeyCode.Semicolon) ||
            Input.GetKey(KeyCode.Quote) ||
            Input.GetKey(KeyCode.Less) ||
            Input.GetKey(KeyCode.Greater) ||
            Input.GetKey(KeyCode.Question) ||
            Input.GetKey(KeyCode.Return) ||
            Input.GetKey(KeyCode.RightShift);

    }

    void UpdateInput()
    {
        fTruckSpeed = BaselineTruckSpeed + theTruck.fBoostValue - theTruck.fSpeedPenalty;

        bShotEngaged = IsShootBeingMashed();
        
        if (IsBoostBeingMashed() && theTruck.fBoost_CurrentPower > 0.0f)
        {
            bBoostEngaged = true;
            bShotEngaged = false;
            theTruck.StartBoostParticles();
        }
        else
        {
            bBoostEngaged = false;
            theTruck.StopBoostParticles();
        }

    }

    public float KeepXValueInCanyon(float incomingX)
    {
        return Mathf.Clamp(incomingX, -4.25f, 4.25f);
    }

    public Vector2 Rotate2DVector(Vector2 rotateMe, float fAngleInDegrees)
    {
        Vector2 retVec = new Vector2();
        float rads = (fAngleInDegrees/360.0f)*6.28f;

        retVec.x = rotateMe.x * Mathf.Cos(rads) - rotateMe.y * Mathf.Sin(rads);
        retVec.y = rotateMe.x * Mathf.Sin(rads) + rotateMe.y * Mathf.Cos(rads);
        return retVec;
    }

    public Vector3 Get2DPositionInRect(Rect targetArea)
    {
        Vector3 retVec = new Vector3(0,0,1);

        retVec.x = Random.Range(targetArea.xMin, targetArea.xMax);
        retVec.y = Random.Range(targetArea.yMin, targetArea.yMax);

        return retVec;
    }

    void OnGUI()
    {

        // Draw Boost on Left Hand Side ======================================================================================
        //GUI.Label( new Rect( 32, 32, 400,400), "Boost: " + theTruck.fBoost_CurrentPower + " / " + theTruck.Boost_MaxPower, fontStyle );
        //GUI.Label(new Rect(32, 48, 400, 400), "Recharge Timer: " + theTruck.fBoost_RechargeTimer, fontStyle);

        GUI.DrawTexture( new Rect(16,100,32,256), tex_BoostGaugeEmpty );

        float fFullnessRatio = theTruck.fBoost_CurrentPower/theTruck.Boost_MaxPower;

        fFullnessRatio += (-0.01f + Random.value*0.02f);
        fFullnessRatio = Mathf.Clamp(fFullnessRatio, 0.0f, 1.0f);

        GUI.DrawTextureWithTexCoords(   new Rect(16, 100 + (256.0f * (1.0f - fFullnessRatio)), 32, 256 * fFullnessRatio),
                                        tex_BoostGaugeFilled,
                                        new Rect(0.0f,0.0f,1.0f,fFullnessRatio));
        
        //Draw Shot on Right Hand Side =======================================================================================

        float fXGuiLoc = Screen.width - 80.0f;

        //GUI.Label(new Rect(fXGuiLoc, 32, 400, 400), "Shot: " + theTruck.fShot_CurrentPower + " / " + theTruck.Shot_MaxPower);
        GUI.DrawTexture(new Rect(fXGuiLoc, 100, 32, 256), tex_BoostGaugeEmpty);

        float fShotFullnessRatio = theTruck.fShot_CurrentPower/theTruck.Shot_MaxPower;

        for (float f = 0f; f < 256.0f; f += 8.0f)
        {
            float fDrawPosY = 100.0f + 256.0f - 8.0f - f;
            float fDrawPosX = fXGuiLoc;

            if (bShotEngaged)
            {
                fDrawPosY += -2.0f + Random.value * 5.0f;
                fDrawPosX += -1.0f + Random.value * 3.0f;
            }
            if (fShotFullnessRatio >= (f/256.0f))
            {
                GUI.DrawTexture(new Rect(fDrawPosX, fDrawPosY, 32, 8), tex_ShotGaugeOneBullet);

                if (f/256.0f > 0.7f)
                    GUI.DrawTexture(new Rect(fDrawPosX, fDrawPosY, 32, 8), tex_ShotGaugeGlow);
            }
        }

        GUI.Label(new Rect(128, 8, 400, 400), "Score: " + iScore, fontStyle);
        float fFakeSpeed = fTruckSpeed;

        fFakeSpeed += Random.value*0.05f;
        GUI.Label(new Rect(600, 8, 400, 400), (fFakeSpeed * 100.0f).ToString("0.00") + "kM/ParSec", fontStyle);


        if (bStaticMode)
        {
            if (iStaticIdx >= staticTextures.Count)
                iStaticIdx = 0;

            GUI.Label(new Rect(-16, -16, Screen.width + 32, Screen.height + 32), staticTextures[iStaticIdx]);
            iStaticIdx++;

            if (iFramesToDoStatic != -999)
            {
                iFramesToDoStatic--;
                if (iFramesToDoStatic <= 0)
                    bStaticMode = false;
            }

            if (bGameOver && fGameIsOverTimer > 4.0f)
            {
                GUI.Label(new Rect(0, 0, Screen.width, Screen.height), tex_gameOverYeah);
                if (!bPlayedGameOverYeah)
                {
                    PlayClip(clip_gameOverYeah);
                    bPlayedGameOverYeah = true;
                }
            }
        }

        if (fShowMessageTextureTimer > 0.0f)
        {
            fShowMessageTextureTimer -= Time.deltaTime;
            GUI.Label(new Rect(0, 0, Screen.width, Screen.height), texMessage);
        }


    }

    public void PlayClip(AudioClip clip)
    {
        GetComponent<AudioSource>().PlayOneShot(clip);
    }
}
