﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

[System.Serializable]
public class WaveEvent
{
    public float fTimeToFire;
    public GameObject ObjectToSpawn;
    public int iNumTimesToSpawn;
    public bool bAlreadyFired;
    public Rect RectSpawnArea;

    public bool bUpgradeTruckTurrets;
    public bool bUpgradeTruckFlames;
    public bool bUpgradeTruckRockets;

    public Texture texToShow;
}



public class WaveManager : MonoBehaviour 
{

    List<WaveEvent> allEventsThisWave;

    private List<WaveEvent> wave1;
    private List<WaveEvent> wave2;
    private List<WaveEvent> wave3;
    private List<WaveEvent> wave4;
        
        

    
    GameManager theGame;
    protected PlayerTruck theTruck;
    protected EnemyManager theEnemyManager;
    protected AudioSource audioSource;

    private bool bSwitchWaveNextTime;
    private List<WaveEvent> switchToMe; 

    float fCurrentTime;

	// Use this for initialization
	void Start () 
    {
        Init();

        allEventsThisWave = new List<WaveEvent>();
        wave1 = new List<WaveEvent>();
        wave2 = new List<WaveEvent>();
        wave3 = new List<WaveEvent>();
        wave4 = new List<WaveEvent>();

        // ==========================================  Wave 1
        #region wave1

        WaveEvent rammin = new WaveEvent();
	    rammin.texToShow = theGame.tex_ExplainRamming;
	    rammin.fTimeToFire = 6.0f;
        wave1.Add(rammin);

        rammin = new WaveEvent();
        rammin.texToShow = theGame.tex_ExplainRamming_02;
        rammin.fTimeToFire = 14.0f;
        wave1.Add(rammin);

        for (int t = 0; t < 10; t++)
        {
            WaveEvent we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeBall");
            we1.RectSpawnArea = new Rect(-4, 12, 8, 8);
            we1.iNumTimesToSpawn = 1;
            we1.fTimeToFire = 5.0f + t * 1.0f;
            wave1.Add(we1);
        }

        for (int t = 0; t < 3; t++)
        {
            WaveEvent we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeWall");
            we1.RectSpawnArea = new Rect(-4, 12, 8, 2);
            we1.iNumTimesToSpawn = 2;
            we1.fTimeToFire = 15.0f + t * 3.0f;
            wave1.Add(we1);

            we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeBall");
            we1.RectSpawnArea = new Rect(-4, 12, 8,2);
            we1.iNumTimesToSpawn = 4;
            we1.fTimeToFire = 15.0f + t * 3.0f;
            wave1.Add(we1);
        }


        for (int t = 0; t < 3; t++)
        {
            WaveEvent we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeWall");
            we1.RectSpawnArea = new Rect(-4, 12, 8, 2);
            we1.iNumTimesToSpawn = 1;
            we1.fTimeToFire = 25.0f + t * 3.0f;
            wave1.Add(we1);

            we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeBall");
            we1.RectSpawnArea = new Rect(-4, 12, 8, 2);
            we1.iNumTimesToSpawn = 2;
            we1.fTimeToFire = 25.0f + t * 3.0f;
            wave1.Add(we1);

            we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_Buggy");
            we1.RectSpawnArea = new Rect(-4, 12, 8, 6);
            we1.iNumTimesToSpawn = 2;
            we1.fTimeToFire = 25.0f + t * 3.0f;
            wave1.Add(we1);
            we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_Buggy");
            we1.RectSpawnArea = new Rect(-4, 12, 8, 6);
            we1.iNumTimesToSpawn = 1;
            we1.fTimeToFire = 25.0f + t * 1.5f;
            wave1.Add(we1);
        }

        WaveEvent we = new WaveEvent();
	    we.bUpgradeTruckTurrets = true;
	    we.fTimeToFire = 40.0f;
        wave1.Add(we);
        


        #endregion

        // ==========================================  Wave 2
        #region wave2

	    for (int t = 0; t < 15; t++)
	    {
	        WaveEvent we1 = new WaveEvent();
	        we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeBall");
	        we1.RectSpawnArea = new Rect(-4, 12, 8, 8);
            we1.iNumTimesToSpawn = Random.Range(2, 5);
	        we1.fTimeToFire = 5.0f + t*2.0f;
	        wave2.Add(we1);

	        if (t%2 == 1)
	        {
	            we1 = new WaveEvent();
	            we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeWall");
	            we1.RectSpawnArea = new Rect(-4, 12, 8, 2);
	            we1.iNumTimesToSpawn = Random.Range(1, 3);
	            we1.fTimeToFire = 5.0f + t*2.0f;
	            wave2.Add(we1);
	        }

	        we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_Buggy");
            we1.RectSpawnArea = new Rect(-4, 12, 8, 6);
            we1.iNumTimesToSpawn = 1;
            we1.fTimeToFire = 5.0f + t * 2.0f;
            wave2.Add(we1);

	        if (t%4 == 3)
	        {
	            we1 = new WaveEvent();
	            we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_Buggy");
	            we1.RectSpawnArea = new Rect(-4, 12, 8, 6);
                we1.iNumTimesToSpawn = Random.Range(2, 5); 
	            we1.fTimeToFire = 5.0f + t*2f;
	            wave2.Add(we1);
	        }

	        if (t > 11)
	        {
                we1 = new WaveEvent();
                we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_RearBiker");
                we1.RectSpawnArea = new Rect(-4, -10, 8, 2);
                we1.iNumTimesToSpawn = 2 + ((t - 12) * 2);
                we1.fTimeToFire = 5.0f + t * 2f;
                wave2.Add(we1);
	        }

	    }

	    we = new WaveEvent();
        we.bUpgradeTruckFlames = true;
        we.fTimeToFire = 38.0f;
        wave2.Add(we);
        
        #endregion

        // ==========================================  Wave 1

        #region wave3

	    for (int t = 0; t < 10; t++)
	    {
	        WaveEvent we1 = new WaveEvent();
	        we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeBall");
	        we1.RectSpawnArea = new Rect(-4, 12, 8, 8);
	        we1.iNumTimesToSpawn = we1.iNumTimesToSpawn = Random.Range(2, 5);
	        we1.fTimeToFire = 5.0f + t*2.0f;
	        wave3.Add(we1);

	        if (t%2 == 1)
	        {
	            we1 = new WaveEvent();
	            we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeWall");
	            we1.RectSpawnArea = new Rect(-4, 12, 8, 2);
	            we1.iNumTimesToSpawn = Random.Range(1, 3);
	            we1.fTimeToFire = 5.0f + t*2.0f;
	            wave3.Add(we1);
	        }

            if (t % 2 == 1)
            {
                we1 = new WaveEvent();
                we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_Buggy");
                we1.RectSpawnArea = new Rect(-4, 12, 8, 6);
                we1.iNumTimesToSpawn = Random.Range(2, 5);
                we1.fTimeToFire = 5.0f + t * 2f;
                wave3.Add(we1);
            }


            we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_RearBiker");
            we1.RectSpawnArea = new Rect(-4, -10, 8, 2);
	        we1.iNumTimesToSpawn = Random.Range(1, 5);
            we1.fTimeToFire = 5.0f + t * 2f;
            wave3.Add(we1);
	    }

        we = new WaveEvent();
        we.bUpgradeTruckRockets = true;
        we.fTimeToFire = 25.0f;
        wave3.Add(we);
        #endregion

        #region wave4

        for (int t = 0; t < 50; t++)
        {
            WaveEvent we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeBall");
            we1.RectSpawnArea = new Rect(-1, 12, 4, 8);
            we1.iNumTimesToSpawn = we1.iNumTimesToSpawn = Random.Range(3, 6);
            we1.fTimeToFire = 3.0f + t * 2.0f;
            wave4.Add(we1);

            if (t % 2 == 1)
            {
                we1 = new WaveEvent();
                we1.ObjectToSpawn = Resources.Load<GameObject>("Obstacle_SpikeWall");
                we1.RectSpawnArea = new Rect(-4, 12, 8, 2);
                we1.iNumTimesToSpawn = Random.Range(1, 3);
                we1.fTimeToFire = 3.0f + t * 2.0f;
                wave4.Add(we1);
            }

            if (t % 2 == 1)
            {
                we1 = new WaveEvent();
                we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_Buggy");
                we1.RectSpawnArea = new Rect(-4, 12, 8, 6);
                we1.iNumTimesToSpawn = Random.Range(3,7);
                we1.fTimeToFire = 3.0f + t * 2f;
                wave4.Add(we1);
            }


            we1 = new WaveEvent();
            we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_RearBiker");
            we1.RectSpawnArea = new Rect(-4, -10, 8, 2);
            we1.iNumTimesToSpawn = Random.Range(2, 9);
            we1.fTimeToFire = 3.0f + t * 2f;
            wave4.Add(we1);
        }
        #endregion



        // ==========================================  Wave 1

	    /*
        for (int t = 0; t < 15; t++)
	    {
	        WaveEvent we1 = new WaveEvent();
	        if (t == 1 || t == 3 || t == 5)
	        {
	            we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_Buggy");
	            we1.RectSpawnArea = new Rect(-4, 12, 8, 8);
	        }
	        else
	        {
                we1.ObjectToSpawn = Resources.Load<GameObject>("Enemy_RearBiker");
                we1.RectSpawnArea = new Rect(-4, -12, 8, 4);
	        }
	        we1.iNumTimesToSpawn = 10;
	        we1.fTimeToFire = 5.0f + t * 1.0f;
            allEventsThisWave.Add(we1);
        }
        */

	    allEventsThisWave = wave1;
    }

    void DoSwitchWave()
    {
        bSwitchWaveNextTime = false;
        fCurrentTime = 0.0f;
        allEventsThisWave = switchToMe;
    }

    public virtual void Init()
    {
        theGame = GameObject.Find("GameManager").GetComponent<GameManager>();
        theTruck = GameObject.Find("PlayerTruck").GetComponent<PlayerTruck>();
        theEnemyManager = GameObject.Find("EnemyManager").GetComponent<EnemyManager>();
        audioSource = GetComponent<AudioSource>();
    }

    public bool IsStaticReady()
    {
        if (allEventsThisWave == wave4 &&
            fCurrentTime > 20.0f)
            return true;

        return false;
    }
	
	// Update is called once per frame
	void Update () 
    {
        fCurrentTime += Time.deltaTime;

        foreach (WaveEvent we in allEventsThisWave)
        {
            if (we.bAlreadyFired || we.fTimeToFire > fCurrentTime)
                continue;

            //fire event
            we.bAlreadyFired = true;

            if (we.texToShow != null)
            {
                theGame.PrepareToShowMessage(we.texToShow);
                break;
            }

            if (we.bUpgradeTruckTurrets)
            {
                theTruck.ActivateMoreTurrets();
                theGame.PrepareToShowMessage(theGame.wave2Intro);
                theGame.BaselineTruckSpeed += 2;
                bSwitchWaveNextTime = true;
                switchToMe = wave2;
                break;
            }

            if (we.bUpgradeTruckFlames)
            {
                theTruck.ActivateFlameThrowers();
                theGame.PrepareToShowMessage(theGame.wave3Intro);
                theGame.BaselineTruckSpeed += 2;
                bSwitchWaveNextTime = true;
                switchToMe = wave3;
                break;
            }

            if (we.bUpgradeTruckRockets)
            {
                theTruck.ActivateRocketLawnchair();
                theGame.PrepareToShowMessage(theGame.wave4Intro);
                theGame.BaselineTruckSpeed += 4;
                bSwitchWaveNextTime = true;
                switchToMe = wave4;
                break;
            }


            for (int t = 0; t < we.iNumTimesToSpawn; t++)
            {
                GameObject go = Instantiate(we.ObjectToSpawn);
                go.transform.position = theGame.Get2DPositionInRect(we.RectSpawnArea);

                //add to lists
                EnemyBase eb = go.GetComponent<EnemyBase>();
                if (eb != null)
                    eb.transform.parent = theEnemyManager.gameObject.transform;
            }
        }

        if( bSwitchWaveNextTime)
            DoSwitchWave();
	}
}
